#ifndef FONT_H
#define FONT_H

#include "Sprite.h"

class Font {
public:
	static const Font BIG, SMALL;

	Font(int, const Sprite *, const Sprite &);

	const Sprite &operator[](int) const;

private:
	int size;
	const Sprite *chars, &error;
};

inline const Sprite &Font::operator[](int index) const {
	if (index >= size)
		return error;
	return chars[index];
}

#endif

