#ifndef SPRITE_H
#define SPRITE_H

class Buffer;

class Sprite {
public:
	Sprite(int, int, unsigned char *);
	Sprite(const Sprite &);

	unsigned char operator[](int) const;
	unsigned char &operator[](int);

	int getWidth() const;
	int getHeight() const;

private:
	int width, height;
	unsigned char *data;
};

static unsigned char SPRITE_DATA[] = {
		0x3c, 0x42, 0xa5, 0x81, 0xa5, 0x99, 0x42, 0x3c
};
static const Sprite SMILY(8, 8, SPRITE_DATA);

inline Sprite::Sprite(int w, int h, unsigned char *d) : width(w), height(h), 
		data(d) { }

inline Sprite::Sprite(const Sprite &other) : width(other.width),
		height(other.height), data(other.data) { }

inline int Sprite::getWidth() const {
	return width;
}

inline int Sprite::getHeight() const {
	return height;
}

#endif

