#include "Calculator.h"
#include "Screen.h"
#include "Sprite.h"
#include "Font.h"
#include "TokenSet.h"

#include "SDL.h"

#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <ctime>

extern "C" {

unsigned short start(void);

static unsigned char FRONT_BUFFER[768], BACK_BUFFER[768];

Calculator *calc;
Buffer *front, *back;

int main(int argc, char **argv) {
	//Calculator theCalc;
	//calc = &theCalc;
	return start();
#if 0

	/*{
		Screen screen(calc);
		for (int i = 0; i < SCREEN_LENGTH; i++)
			screen[i] = 0xff;
		int i = 128;
		for (int y = 1; y < 64; y += 8)
			for (int x = 0; x < 96; x += 6)
				Font::SMALL[i++].renderXor(screen, x, y);
	}*/


	const char data[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ! also:", *ptr = data;
	int x = 0, y = 0, t = 0;
	while (calc.running()) {
		SDL_Delay(10000);
		Screen screen(calc);
		for (int i = 0; i < SCREEN_LENGTH; i++)
			screen[i] = 0;
		for (int i = 0; i < 8; i++, y += 8) {
			TokenSet::TIOS.render(Buffer::OFF, t++, Font::BIG, screen, x, y);
			screen.draw(Buffer::OFF, Font::BIG[0x7c]);
		}
		y = 0;
	}
	{
		Screen screen(calc);
		//TokenSet::TIOS.renderOff(1, Font::BIG, screen, x, y);
		//y += 8;
		for (int i = 0; i < 128; i++) {
			screen.move(x, y);
			screen.draw(Screen::OFF, Font::BIG[i]);
			//Font::BIG[i].renderOff(screen, x, y);
		//while (*ptr) {
			//Font::BIG[*ptr++].renderOff(screen, x, y);
			if ((x += 6) >= 96) {
				x = 0;
				y += 8;
			}
		}
	}	
	//{
		//Screen screen(calc);
		//for (int i = 0; i < SCREEN_LENGTH >> 1; ++i)
			//screen[i] = 0xff;
	//}
	//while (calc.running()) {
		//SDL_Delay(10);
		//Screen screen(calc);
		//SMILY.renderOff(screen, (rand() & 0xff) - 0x80, (rand() & 0xff) - 0x80);
		//for (int i = 0; i < SCREEN_LENGTH && calc.running(); i++)
			//screen[rand() % SCREEN_LENGTH] ^= 1 << (rand() % 8);
	//}
	return 0;
#endif
}

void init(void) {
	srand(time(NULL));
	calc = new Calculator;
	front = new Buffer(96, 64, FRONT_BUFFER);
	back = new Buffer(96, 64, BACK_BUFFER);
}

unsigned short getkey(void) {
	return false;
}

unsigned short rnd(void) {
	return rand();
}

void pause(unsigned short amount) {
	SDL_Delay(amount);
}

void full(void) {
	
}

void normal(void) {
	
}

void inton(void) {
	
}

void intoff(void) {
	
}

void diagon(void) {
	
}

void diagoff(void) {
	
}

void clrfront(void) {
	memset(FRONT_BUFFER, 0, sizeof(FRONT_BUFFER));
}

void clrback(void) {
	memset(BACK_BUFFER, 0, sizeof(BACK_BUFFER));
}

void dispgraph(void);

static unsigned char WHITE_PIXEL_DATA = 0x00;
static unsigned char BLACK_PIXEL_DATA = 0x80;
static const Sprite WHITE_PIXEL(1, 1, &WHITE_PIXEL_DATA);
static const Sprite BLACK_PIXEL(1, 1, &BLACK_PIXEL_DATA);

void pxlon(unsigned char x, unsigned char y) {
	//(*front)[(x >> 3) + y * (front->getWidth() + 7 >> 3)] |= 0x80 >> (x & 7);
	//printf("Pxl-On(%hhu, %hhu)\n", x, y);
	front->move(x, y);
	front->draw(Buffer::ON, BLACK_PIXEL);
}

void pxlchange(unsigned char x, unsigned char y) {
	//(*front)[(x >> 3) + y * (front->getWidth() + 7 >> 3)] ^= 0x80 >> (x & 7);
	//printf("Pxl-Change(%hhu, %hhu)\n", x, y);
	front->move(x, y);
	front->draw(Buffer::CHANGE, BLACK_PIXEL);
}

void pxloff(unsigned char x, unsigned char y) {
	//(*front)[(x >> 3) + y * (front->getWidth() + 7 >> 3)] &= ~(0x80 >> (x & 7));
	//printf("Pxl-On(%hhu, %hhu)\n", x, y);
	front->move(x, y);
	front->draw(Buffer::OFF, WHITE_PIXEL);
}

unsigned short pxltest(unsigned char x, unsigned char y) {
	//return ((*front)[(x >> 3) + y * (front->getWidth() + 7 >> 3)] & (0x80 >> (x & 7))) != 0;
	//printf("pxl-Test(%hhu, %hhu)\n", x, y);
	unsigned char data = 0;
	Sprite sprite(1, 1, &data);
	front->move(x, y);
	front->draw(Buffer::GET, sprite);
	return data != 0;
}

void backpxlon(unsigned char x, unsigned char y) {
	//(*back)[(x >> 3) + y * (back->getWidth() + 7 >> 3)] |= 0x80 >> (x & 7);
	//printf("Pxl-On(%hhu, %hhu)r\n", x, y);
	back->move(x, y);
	back->draw(Buffer::ON, BLACK_PIXEL);
}

void backpxlchange(unsigned char x, unsigned char y) {
	//(*back)[(x >> 3) + y * (back->getWidth() + 7 >> 3)] ^= 0x80 >> (x & 7);
	//printf("Pxl-Change(%hhu, %hhu)r\n", x, y);
	back->move(x, y);
	back->draw(Buffer::CHANGE, BLACK_PIXEL);
}

void backpxloff(unsigned char x, unsigned char y) {
	//(*back)[(x >> 3) + y * (back->getWidth() + 7 >> 3)] &= ~(0x80 >> (x & 7));
	//printf("Pxl-On(%hhu, %hhu)r\n", x, y);
	back->move(x, y);
	back->draw(Buffer::OFF, WHITE_PIXEL);
}

unsigned short backpxltest(unsigned char x, unsigned char y) {
	//return ((*back)[(x >> 3) + y * (back->getWidth() + 7 >> 3)] & (0x80 >> (x & 7))) != 0;
	//printf("pxl-Test(%hhu, %hhu)r\n", x, y);
	unsigned char data = 0;
	Sprite sprite(1, 1, &data);
	back->move(x, y);
	back->draw(Buffer::GET, sprite);
	return data != 0;
}

void spriteon(unsigned char x, unsigned char y, unsigned char *sprite) {
	front->move(x, y);
	front->draw(Buffer::ON, Sprite(8, 8, sprite));
}

void spriteoff(unsigned char x, unsigned char y, unsigned char *sprite) {
	front->move(x, y);
	front->draw(Buffer::OFF, Sprite(8, 8, sprite));
}

void spritechange(unsigned char x, unsigned char y, unsigned char *sprite) {
	front->move(x, y);
	front->draw(Buffer::CHANGE, Sprite(8, 8, sprite));
}

void spriteget(unsigned char x, unsigned char y, unsigned char *sprite) {
	front->move(x, y);
	Sprite buffer(8, 8, sprite);
	front->draw(Buffer::GET, buffer);
}

void backspriteon(unsigned char x, unsigned char y, unsigned char *sprite) {
	back->move(x, y);
	back->draw(Buffer::ON, Sprite(8, 8, sprite));
}

void backspriteoff(unsigned char x, unsigned char y, unsigned char *sprite) {
	back->move(x, y);
	back->draw(Buffer::OFF, Sprite(8, 8, sprite));
}

void backspritechange(unsigned char x, unsigned char y, unsigned char *sprite) {
	back->move(x, y);
	back->draw(Buffer::CHANGE, Sprite(8, 8, sprite));
}

void backspriteget(unsigned char x, unsigned char y, unsigned char *sprite) {
	back->move(x, y);
	Sprite buffer(8, 8, sprite);
	back->draw(Buffer::GET, buffer);
}

void dispgraph(void) {
	{
		Screen screen(*calc);
		for (int i = 0; i < sizeof(FRONT_BUFFER); ++i)
			screen[i] = (*front)[i];
	}
	SDL_Delay(250);
}

void clrhome(void) {
	{
		Screen screen(*calc);
		screen.move(0, 0);
		for (int i = 0; i < sizeof(FRONT_BUFFER); ++i)
			screen[i] = 0;
	}
}

void dispstr(unsigned char *str) {
	{
		Screen screen(*calc);
		while (*str) {
			if (screen.getX() > screen.getWidth())
				screen.moveBy(-screen.getX(), 8);
			screen.draw(Buffer::OFF, Font::BIG[*str++]);
		}
	}
}

void output(char x, char y, unsigned char *str) {
	{
		Screen screen(*calc);
		screen.move(x * 6, y * 8);
		while (*str)
			screen.draw(Buffer::OFF, Font::BIG[*str++]);
	}
}

} // extern "C"

